// Arduino UNO sketch
// Original version by Insert Coin
// https://www.racedepartment.com/threads/easy-diy-wind-simulator-for-assetto-corsa.133999/
//
// Thanks to afremont for his PWM logic,
// see https://forum.arduino.cc/index.php?topic=155089.45
//
// Thanks to mongo56 for his idea ACFan and source code,
// see https://www.reddit.com/r/oculus/comments/2b8d3m/assetto_corsa_fan_control/

const int PWMPin = 3;

void setup() {
  Serial.begin(9600);
 
  // generate 25kHz PWM pulse rate on Pin 3
  pinMode(PWMPin, OUTPUT);   // OCR2B sets duty cycle
  // Set up Fast PWM on Pin 3
  TCCR2A = 0x23;     // COM2B1, WGM21, WGM20
  // Set prescaler  
  TCCR2B = 0x0A;   // WGM21, Prescaler = /8
  // Set TOP and initialize duty cycle to zero(0)
  OCR2A = 79;    // TOP DO NOT CHANGE, SETS PWM PULSE RATE

  // start-up sequence: let the user know we are working OK
  // start fan at lowest speed
  OCR2B = 0;   // duty cycle for Pin 3 (0-79) generates 1 500nS pulse even when 0 :(
}

void loop() {
  // waiting for data coming from ACFan.exe
  // which retrieves the speed from Assetto Corsa,
  // converts it to a string and sends it to the Arduino
  if(Serial.available() > 0)
  {
    char ch = Serial.read();
    OCR2B = ch;
  }
}

